use crate::prelude::*;

use std::os::raw::c_void;
use std::ptr;

#[repr(C)]
pub struct VkAccelerationStructureCreateInfoKHR {
    pub sType: VkStructureType,
    pub pNext: *const c_void,
    pub createFlags: VkAccelerationStructureCreateFlagBitsKHR,
    pub buffer: VkBuffer,
    pub offset: VkDeviceSize,
    pub size: VkDeviceSize,
    pub r#type: VkAccelerationStructureTypeKHR,
    pub deviceAddress: VkDeviceAddress,
}

impl VkAccelerationStructureCreateInfoKHR {
    pub fn new(
        create_flags: impl Into<VkAccelerationStructureCreateFlagBitsKHR>,
        buffer: VkBuffer,
        offset: VkDeviceSize,
        size: VkDeviceSize,
        r#type: VkAccelerationStructureTypeKHR,
        device_address: VkDeviceAddress,
    ) -> Self {
        VkAccelerationStructureCreateInfoKHR {
            sType: VK_STRUCTURE_TYPE_ACCELERATION_STRUCTURE_CREATE_INFO_KHR,
            pNext: ptr::null(),
            createFlags: create_flags.into(),
            buffer,
            offset,
            size,
            r#type,
            deviceAddress: device_address,
        }
    }
}
