use crate::prelude::*;

use std::os::raw::c_void;
use std::ptr;

#[repr(C)]
pub struct VkAccelerationStructureDeviceAddressInfoKHR {
    pub sType: VkStructureType,
    pub pNext: *const c_void,
    pub accelerationStructure: VkAccelerationStructureKHR,
}

impl VkAccelerationStructureDeviceAddressInfoKHR {
    pub fn new(acceleration_structure: VkAccelerationStructureKHR) -> Self {
        VkAccelerationStructureDeviceAddressInfoKHR {
            sType: VK_STRUCTURE_TYPE_ACCELERATION_STRUCTURE_DEVICE_ADDRESS_INFO_KHR,
            pNext: ptr::null(),
            accelerationStructure: acceleration_structure,
        }
    }
}
