use crate::prelude::*;

use std::os::raw::c_void;
use std::ptr;

#[repr(C)]
#[derive(Debug)]
pub struct VkPhysicalDeviceRayTracingFeaturesKHR {
    pub sType: VkStructureType,
    pub pNext: *mut c_void,
    pub rayTracingPipeline: VkBool32,
    pub rayTracingPipelineShaderGroupHandleCaptureReplay: VkBool32,
    pub rayTracingPipelineShaderGroupHandleCaptureReplayMixed: VkBool32,
    pub rayTracingPipelineTraceRaysIndirect: VkBool32,
    pub rayTraversalPrimitiveCulling: VkBool32,
}

impl Default for VkPhysicalDeviceRayTracingFeaturesKHR {
    fn default() -> Self {
        VkPhysicalDeviceRayTracingFeaturesKHR {
            sType: VK_STRUCTURE_TYPE_PHYSICAL_DEVICE_RAY_TRACING_PIPELINE_FEATURES_KHR,
            pNext: ptr::null_mut(),
            rayTracingPipeline: VK_FALSE,
            rayTracingPipelineShaderGroupHandleCaptureReplay: VK_FALSE,
            rayTracingPipelineShaderGroupHandleCaptureReplayMixed: VK_FALSE,
            rayTracingPipelineTraceRaysIndirect: VK_FALSE,
            rayTraversalPrimitiveCulling: VK_FALSE,
        }
    }
}

unsafe impl Sync for VkPhysicalDeviceRayTracingFeaturesKHR {}
unsafe impl Send for VkPhysicalDeviceRayTracingFeaturesKHR {}
